<?php
/*
  $Id: attributeManager.php,v 3.6.0

  by @raiwa
  raiwa@phoenixcartaddons.com
  www.phoenixcartaddons.com

  Copyright © 2021 Rainer Schmied

  based on attributeManager.php,v 1.0 21/02/06 Sam West$

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Released under the GNU General Public License

  Copyright © 2006 Kangaroo Partners
  http://kangaroopartners.com
  osc@kangaroopartners.com
*/

// change the directory upone for application top includes
chdir('../');

// OSC application top needed for sessions, defines and functions
require_once 'includes/application_top.php';

// db wrapper
require_once 'attributeManager/classes/amDB.class.php';

// session functions
require_once 'attributeManager/includes/attributeManagerSessionFunctions.inc.php';

// config
require_once 'attributeManager/classes/attributeManagerConfig.class.php';

// misc functions
require_once 'attributeManager/includes/attributeManagerGeneralFunctions.inc.php';

// parent class
require_once 'attributeManager/classes/attributeManager.class.php';

// instant class
require_once 'attributeManager/classes/attributeManagerInstant.class.php';

// security class
require_once 'attributeManager/classes/stopDirectAccess.class.php';

// check that the file is allowed to be accessed
stopDirectAccess::checkAuthorisation(AM_SESSION_VALID_INCLUDE);


// get an instance of one of the attribute manager classes
$attributeManager = amGetAttributeManagerInstance($_GET);

// do any actions that should be done
$globalVars = $attributeManager->executePageAction($_GET);


// set any global variables from the page action execution
if ( isset($globalVars) && (0 !== count($globalVars)) && is_array($globalVars) ) {
  foreach ($globalVars as $varName => $varValue) {
    $$varName = $varValue;
  }
}

// get the current products options and values
$allProductOptionsAndValues = $attributeManager->getAllProductOptionsAndValues(true);


// count the options
$numOptions = count($allProductOptionsAndValues);
// output a response header
header('Content-type: text/html; charset=' . CHARSET);

//$attributeManager->debugOutput($allProductOptionsAndValues);
//$attributeManager->debugOutput($SortedProductAttributes);
//$attributeManager->debugOutput($attributeManager);

// include any prompts
require_once 'attributeManager/includes/attributeManagerPrompts.inc.php';

if (!isset($_GET['target']) || 'topBar' == $_GET['target'] ) {
  if (!isset($_GET['target'])) {
    echo '<div id="topBar">';
  }
?>

<table class="table table-sm">
  <tr>
    <td class="align-middle" width="50%">
    <?php
    $languages = language::load_all();
    if (count($languages) > 1) {
      foreach ($languages as $amLanguage) {
        if ($attributeManager->getSelectedLanaguage() == $amLanguage['id']) {
          echo '&nbsp;<button class="btn btn-info" type="button">' . $Admin->catalog_image('includes/languages/' . $amLanguage['directory'] . '/images/' . $amLanguage['image'], ['class' => 'lng mr-2'], $amLanguage['name']) . $amLanguage['name'] . '</button>';
        } else {
          echo '&nbsp;<button class="btn btn-outline-info" type="button" onclick="return amSetInterfaceLanguage(\''.$amLanguage['id'].'\');">' . $Admin->catalog_image('includes/languages/' . $amLanguage['directory'] . '/images/' . $amLanguage['image'], ['class' => 'lng mr-2'], $amLanguage['name']) . $amLanguage['name'] . '</button>';
        }
      }      
    }
?>
    </td>
    <td class="align-middle text-right">

    <?php
    if (AM_USE_TEMPLATES == 'true') {
      if ($attributeManager->getTemplateOrder() == '123') {
        echo '<button type="button" class="btn btn-success btn-sm" data-toggle="popup" data-placement="top" title="' . AM_AJAX_LOADS_SELECTED_TEMPLATE . '" onclick="return amTemplateOrder(\'123\');">123</button>';
      } else {
        echo '<button type="button" class="btn btn-outline-success btn-sm" data-toggle="popup" data-placement="top" title="' . AM_AJAX_LOADS_SELECTED_TEMPLATE . '" onclick="return amTemplateOrder(\'123\');">123</button>';
      }

      if($attributeManager->getTemplateOrder()=='abc'){
        echo '<button type="button" class="btn btn-success btn-sm" data-toggle="popup" data-placement="top" title="' . AM_AJAX_LOADS_SELECTED_TEMPLATE . '" onclick="return amTemplateOrder(\'abc\');">abc</button>';
      } else {
        echo '<button type="button" class="btn btn-outline-success btn-sm" data-toggle="popup" data-placement="top" title="' . AM_AJAX_LOADS_SELECTED_TEMPLATE . '" onclick="return amTemplateOrder(\'abc\');">abc</button>';
      }
    ?>
    </td>
    <td class="align-middle">
      <?= (new Select('template_drop', $attributeManager->buildAllTemplatesDropDown($attributeManager->getTemplateOrder()), ['id' => 'template_drop', 'class' => 'form-control form-control-sm']))->set_selection(((!isset($selectedTemplate)) || (0 == $selectedTemplate)) ? '0' : $selectedTemplate) ?>
    </td>
    <td class="align-middle">
        <button type="button" class="btn btn-success btn-sm" data-toggle="popup" data-placement="top" title="<?= AM_AJAX_LOADS_SELECTED_TEMPLATE ?>" onclick="return customTemplatePrompt('loadTemplate');"><i class="fas fa-upload"></i></button>
        <button type="button" class="btn btn-success btn-sm" data-toggle="popup" data-placement="top" title="<?= AM_AJAX_SAVES_ATTRIBUTES_AS_A_NEW_TEMPLATE ?>" onclick="return customPrompt('saveTemplate');"><i class="fas fa-save"></i></button>
        <button type="button" class="btn btn-success btn-sm" data-toggle="popup" data-placement="top" title="<?= AM_AJAX_RENAMES_THE_SELECTED_TEMPLATE ?>" onclick="return customTemplatePrompt('renameTemplate');"><i class="fas fa-edit"></i></button>
        <button type="button" class="btn btn-danger btn-sm" data-toggle="popup" data-placement="top" title="<?= AM_AJAX_DELETES_THE_SELECTED_TEMPLATE ?>" onclick="return customTemplatePrompt('deleteTemplate');"><i class="fas fa-trash"></i></button>
      <?php
    }
   ?>
    </td>
  </tr>
</table>
<?php
  if (!isset($_GET['target'])) {
    echo '</div>';
  }
} // end target = topBar

if (!isset($_GET['target'])) {
  echo '<div id="attributeManagerAll">';
}
?>
<?php
if (!isset($_GET['target']) || 'currentAttributes' == $_GET['target']) {
  if (!isset($_GET['target'])) {
    echo '<div id="currentAttributes">';
  }
?>
  <table class="table table-sm">
    <thead class="thead-dark">
      <tr>
        <th class="text-right">
          <button type="button" class="btn btn-light btn-sm" onclick="return amShowHideAllOptionValues([<?= implode(',',array_keys($allProductOptionsAndValues));?>],true);"><i class="fas fa-folder-open"></i></button>
        </th>
        <th>
          <button type="button" class="btn btn-light btn-sm" onclick="return amShowHideAllOptionValues([<?= implode(',',array_keys($allProductOptionsAndValues));?>],false);"><i class="fas fa-folder"></i></button>
        </th>
        <th>
        <?= AM_AJAX_NAME ?>
        </th>
        <th>
          <?= AM_AJAX_VALUE ?>
        </th>

        <th colspan="6">
          <span style="margin-right:40px"><?= AM_AJAX_ACTION ?></span>
        </th>
        <?php
        // wholesale added by @BrockleyJohn 
        if (AM_USE_WHOLESALE == 'true') {
          ?><th colspan="1"></th><?php
        }
        if (AM_USE_IMAGE == 'true') {
         ?><th colspan="4"></th><?php
        }
        if (AM_USE_MPW == 'true') {
         ?><th colspan="3"></th><?php
        }
        ?><th class="text-center"colspan="2"><?= AM_AJAX_SORT ?></th>
      </tr>
    </thead>
    <tbody>

    <?php
    if (0 < $numOptions) {
      foreach ($allProductOptionsAndValues as $optionId => $optionInfo) {
        $numValues = count($optionInfo['values']);
      ?>
        <tr class="table-primary option">
          <td class="text-center align-middle" colspan="2">
          <button type="button" class="btn btn-light btn-sm"  id="show_hide_<?= $optionId ?>" onclick="return amShowHideOptionsValues(<?= $optionId ?>);"><i class="fas fa-folder"></i></button>
          </td>
          <td class="align-middle">
            <?= "{$optionInfo['name']} ($numValues)";?>
          </td>

          <td>
            <?= (new Select('new_option_value_' . $optionId, $attributeManager->buildOptionValueDropDown($optionId), ['id' => 'new_option_value_' . $optionId, 'style' => 'margin:3px 0px 3px 0px;', 'class' => 'form-control form-control-sm']))->set_selection(((!isset($selectedOptionValue)) || (0 == $selectedOptionValue)) ? '0' : $selectedOptionValue) ?>
          </td>

          <td class="align-middle" colspan="3">

            <button type="button" class="btn btn-success btn-sm" data-toggle="popup" data-placement="top" title="<?= htmlspecialchars(sprintf(AM_AJAX_ADDS_ATTRIBUTE_TO_OPTION, $optionInfo['name'])) ?>" onclick="return amAddOptionValueToProduct('<?= $optionId?>');"><i class="fas fa-check-circle"></i></button>
            <button type="button" class="btn btn-secondary btn-sm" data-toggle="popup" data-placement="top" title="<?= htmlspecialchars(sprintf(AM_AJAX_ADDS_NEW_VALUE_TO_OPTION,$optionInfo['name'])) ?>" onclick="return customPrompt('amAddNewOptionValueToProduct','<?= addslashes("option_id:$optionId|option_name:".str_replace('"','&quot;',$optionInfo['name']))?>');"><i class="fas fa-plus-circle"></i></button>
            <button type="button" class="btn btn-danger btn-sm" data-toggle="popup" data-placement="top" title="<?= htmlspecialchars(addslashes(sprintf(AM_AJAX_PRODUCT_REMOVES_OPTION_AND_ITS_VALUES,$optionInfo['name'],$numValues))) ?>" onClick="return customPrompt('amRemoveOptionFromProduct','<?= addslashes("option_id:$optionId|option_name:".str_replace('"','&quot;',$optionInfo['name']))?>');"><i class="fas fa-minus-circle"></i></button>
          </td>
          <td colspan="3"></td>
          <?php
          // wholesale added by @BrockleyJohn 
          if (AM_USE_WHOLESALE == 'true') {
            ?><td colspan="1"></td><?php
          }
          if (AM_USE_IMAGE == 'true') {
            ?><td colspan="4" align="right"></td><?php
          }
          if (AM_USE_MPW == 'true') {
            ?><td colspan="3"></td><?php
          }
          ?>
          <td class="align-middle text-right">
            <button type="button" class="btn btn-info btn-sm" data-toggle="popup" data-placement="top" title="<?= AM_AJAX_MOVES_OPTION_UP ?>" onclick="return amMoveOption('<?= 'option_id:'.$optionId  ?>', 'up');"><i class="fas fa-angle-double-up" aria-hidden="true"></i></button>
          </td>
          <td class="align-middle">
            <button type="button" class="btn btn-info btn-sm" data-toggle="popup" data-placement="top" title="<?= AM_AJAX_MOVES_OPTION_DOWN ?>" onclick="return amMoveOption('<?= 'option_id:'.$optionId  ?>', 'down');"><i class="fas fa-angle-double-down" aria-hidden="true"></i></button>
          </td>
        </tr>
      </tbody>
      <tbody>
<!-- ----- -->
<!-- Show Option Values -->
<!-- ----- -->
  <?php
      if (0 < $numValues) {
        foreach ( $optionInfo['values'] as $optionValueId => $optionValueInfo ) {
  ?>
      <tr class="optionValue" id="trOptionsValues_<?= $optionId ?>" style="display:none" >
        <td class="align-middle text-right" colspan="2">
          <i class="fas fa-folder-open" aria-hidden="true">
        </td>
        <td>
        </td>
        <td class="align-middle">
          <?= $optionValueInfo['name'] ?>
        </td>

          <td class="align-middle text-right">
            <?= AM_AJAX_FILENAME ?>
          </td>
<?php
          if(isset($optionValueInfo['products_attributes_filename'])){
            ?>
            <td class="align-middle text-right">
              <button type="button" class="btn btn-success btn-sm" aria-haspopup="true" data-toggle="popover" data-placement="top" data-content="<?= htmlspecialchars(sprintf(AM_AJAX_DOWLNOAD_EDIT,$optionValueInfo['name'],$optionInfo['name'])) ?>" onClick="return customPrompt('amEditDownloadForProduct','<?= addslashes('option_id:' . $optionId . '|products_attributes_filename:' . $optionValueInfo['products_attributes_filename'] . '|products_attributes_maxdays:'.$optionValueInfo['products_attributes_maxdays']  . '|products_attributes_maxcount:'.$optionValueInfo['products_attributes_maxcount'] .'|option_value_name:'.str_replace('"','&quot;',$optionValueInfo['name'] .'|products_attributes_id:'.$optionValueInfo['products_attributes_id']))?>');"><i class="fas fa-edit"></i></button>
            </td>
            <td class="align-middle">
              <button type="button" class="btn btn-danger btn-sm" data-toggle="popup" data-placement="top" title="<?= htmlspecialchars(sprintf(AM_AJAX_DOWLNOAD_DELETE,$optionValueInfo['name'],$optionInfo['name'])) ?>" onClick="return customPrompt('amDeleteDownloadForProduct','<?= addslashes('option_id:' . $optionId . '|option_value_name:'.str_replace('"','&quot;',$optionValueInfo['name']) .'|products_attributes_id:'.$optionValueInfo['products_attributes_id'])?>');"><i class="fas fa-trash"></i></button>
            </td>
            <?php
          } else {
            ?>
            <td class="align-middle">
              <button type="button" class="btn btn-success btn-sm" data-toggle="popup" data-placement="top" title="<?= htmlspecialchars(sprintf(AM_AJAX_DOWLNOAD_ADD_NEW,$optionValueInfo['name'],$optionInfo['name'])) ?>" onClick="return customPrompt('amAddNewDownloadForProduct','<?= addslashes('option_id:' . $optionId .'|option_value_id:'.$optionValueId . '|option_value_name:'.str_replace('"','&quot;',$optionValueInfo['name']).'|products_attributes_id:'.$optionValueInfo['products_attributes_id'])?>');"><i class="fas fa-save"></i></button>
            </td>
            <td></td>
            <?php
          }
//----------------------------
// EOF Change: download attributes for AM
//-----------------------------
          ?>
          <td>
            <?= drawDropDownPrefix(['id' => 'prefix_' . $optionValueId, 'class' => 'form-control form-control-sm', 'style' => 'margin:3px 0px 3px 0px;', 'onChange' => 'return amUpdate(\'' . $optionId . '\',\'' . $optionValueId . '\',\'prefix\');'], $optionValueInfo['prefix']);?>
          </td>
          <td>
            <?= new Input('price_' . $optionValueId, ['value' => $optionValueInfo['price'], 'style' => 'margin:3px 0px 3px 0px;', 'id' => 'price_' . $optionValueId, 'size' => '7', 'onfocus' => 'amF(this)', 'onblur' => 'amB(this)', 'onChange' => "return amUpdate('" . $optionId . "','" . $optionValueId . "','price');", 'class' => 'form-control form-control-sm']) ?>

         </td>
          <?php
          // wholesale added by @BrockleyJohn 
          if (AM_USE_WHOLESALE == 'true') {
            ?>
          <td>
            <?= new Input('ws_price_' . $optionValueId, ['value' => $optionValueInfo['ws_price'], 'style' => 'margin:3px 0px 3px 0px;', 'id' => 'ws_price_' . $optionValueId, 'size' => '7', 'onfocus' => 'amF(this)', 'onblur' => 'amB(this)', 'onChange' => "return amUpdate('" . $optionId . "','" . $optionValueId . "','ws_price');", 'class' => 'form-control form-control-sm']) ?>
          </td>
            <?php
          }
          if (AM_USE_IMAGE == 'true') {
            ?>
            <td class="align-middle text-right">
              <?= AM_AJAX_IMAGE ?>
            </td>
            <?php
            if ($optionValueInfo['product_option_image'] == true ) {
              ?>
              <td class="align-middle text-right">
                <button type="button" class="btn btn-success btn-sm" data-toggle="popup" data-placement="top" title="<?= htmlspecialchars(sprintf(AM_AJAX_IMAGE_EDIT,$optionValueInfo['name'],$optionInfo['name'])) ?>" onClick="return customPrompt('amAddNewImageForProduct','<?= addslashes('option_id:' . $optionId .'|option_value_id:'.$optionValueId . '|option_value_name:'.str_replace('"','&quot;',$optionValueInfo['name']).'|option_image:'.str_replace('"','&quot;',$optionValueInfo['image']) .'|option_value_name:'.str_replace('"','&quot;',$optionValueInfo['name'] .'|products_attributes_id:'.$optionValueInfo['products_attributes_id']))?>');"><i class="fas fa-edit" aria-hidden="true"></i></button>
              </td>
              <td class="align-middle text-right">
                <button type="button" class="btn btn-danger btn-sm" data-toggle="popup" data-placement="top" title="<?= htmlspecialchars(sprintf(AM_AJAX_IMAGE_DELETE,$optionValueInfo['name'],$optionInfo['name'])) ?>" onClick="return customPrompt('amDeleteImageForProduct','<?= addslashes('option_id:' . $optionId . '|option_value_id:'.$optionValueId . '|option_value_name:'.str_replace('"','&quot;',$optionValueInfo['name']) . '|products_attributes_id:'.$optionValueInfo['products_attributes_id'])?>');"><i class="fas fa-trash" aria-hidden="true"></i></button>
              </td>
              <?php
            } else {
              ?>
              <td class="align-middle text-right">
                <button type="button" class="btn btn-success btn-sm" data-toggle="popup" data-placement="top" title="<?= htmlspecialchars(sprintf(AM_AJAX_IMAGE_ADD_NEW,$optionValueInfo['name'],$optionInfo['name'])) ?>" onClick="return customPrompt('amAddNewImageForProduct','<?= addslashes('option_id:' . $optionId .'|option_value_id:'.$optionValueId . '|option_value_name:'.str_replace('"','&quot;',$optionValueInfo['name']).'|products_attributes_id:'.$optionValueInfo['products_attributes_id'])?>');"><i class="fas fa-save" aria-hidden="true"></i></button>
              </td>
              <td class="align-middle text-right">
              </td>
              <?php
            }
              ?>
              <td class="align-middle">
                <?php
                if ( !Text::is_empty($optionValueInfo['image']) ) {
                  echo $Admin->catalog_image('images/options/' . $optionValueInfo['image'], [], $optionValueInfo['image'], '40px', '40px');
                }
                ?>
              </td>
            <?php
          }
// More Product Weight added by RusNN
          if (AM_USE_MPW == 'true') {
            ?>
            <td class="align-middle">
            <?= AM_AJAX_WEIGHT  ?>
            </td>
            <td class="align-middle">
            <?= drawDropDownWeightPrefix(['id' => 'weight_prefix_' . $optionValueId, 'class' => 'form-control form-control-sm', 'style' => 'margin:3px 0px 3px 0px;', 'onChange' => 'return amUpdate(\'' . $optionId . '\',\'' . $optionValueId . '\',\'weight_prefix\');'], $optionValueInfo['weight_prefix']);?>
            </td>
            <td class="align-middle">
            <?= new Input('weight_' . $optionValueId, ['value' => $optionValueInfo['weight'], 'style' => 'margin:3px 0px 3px 0px;', 'id' => 'weight_' . $optionValueId, 'size' => '7', 'onfocus' => 'amF(this)', 'onblur' => 'amB(this)', 'onChange' => "return amUpdate('" . $optionId . "','" . $optionValueId . "','weight');", 'class' => 'form-control form-control-sm']) ?>
            </td>
            <?php
          }
          ?>
          <td class="align-middle">
            <button type="button" class="btn btn-danger btn-sm" data-toggle="popup" data-placement="top" title="<?= htmlspecialchars(sprintf(AM_AJAX_PRODUCT_REMOVES_VALUE_FROM_OPTION,$optionValueInfo['name'],$optionInfo['name'])) ?>" onClick="return customPrompt('amRemoveOptionValueFromProduct','<?= addslashes("option_id:$optionId|option_value_id:$optionValueId|option_value_name:".str_replace('"','&quot;',$optionValueInfo['name']))?>');" /><i class="fas fa-minus-circle"></i></button>
          </td>
          <td class="align-middle text-right">
            <button type="button" class="btn btn-info btn-sm" data-toggle="popup" data-placement="top" title="<?= AM_AJAX_MOVES_VALUE_UP ?>" onclick="return amMoveOptionValue('<?= 'option_id:'.$optionId.'|option_value_id:'.$optionValueId.'|products_attributes_id:'.$optionValueInfo['products_attributes_id'] ?>', 'up');" /><i class="fas fa-angle-double-up" aria-hidden="true"></i></button>
          </td>
          <td class="align-middle">
            <button type="button" class="btn btn-info btn-sm" data-toggle="popup" data-placement="top" title="<?= AM_AJAX_MOVES_VALUE_DOWN ?>" onclick="return amMoveOptionValue('<?= 'option_id:'.$optionId.'|option_value_id:'.$optionValueId.'|products_attributes_id:'.$optionValueInfo['products_attributes_id'] ?>', 'down');" /><i class="fas fa-angle-double-down" aria-hidden="true"></i></button>
          </td>
        </tr>
        <?php
        }
      }
        ?>
      </tbody>
  <?php
    }
  }
  ?>
<!-- ----- -->
<!-- EOF Show Option Values -->
<!-- ----- -->
  </table>
  <?php
  if (!isset($_GET['target']) ) {
    echo '</div>';
  }
} // end target = currentAttributes


if (!isset($_GET['target']) || 'newAttribute' == $_GET['target'] ) {
  if(!isset($_GET['target']))
    echo '<div id="newAttribute">';

  // check to see if the selected option isset if it isn't pick the first otion in the dropdown
  $optionDrop = $attributeManager->buildOptionDropDown();

  if ( (!isset($selectedOption)) ||(!is_numeric($selectedOption)) ) {
    foreach ($optionDrop as $key => $value) {
      if (!Text::is_empty($value['id'])) {
        $selectedOption = $value['id'];
        break;
      }
    }
  }

  $optionValueDrop = $attributeManager->buildOptionValueDropDown($selectedOption);
?>
<!-- ----- -->
<!-- SHOW NEW OPTION PANEL on Bottom -->
<!-- ----- -->
  <table class="table table-sm mb-0">
    <thead class="thead-dark">
      <tr>
        <th><?= AM_AJAX_OPTION_NEW_PANEL ?></th>
      </tr>
    </thead>
  </table>
  <table class="table table-sm mt-0">
    <tbody>
      <tr>
        <td class="align-middle">
          <?= AM_AJAX_OPTION ?>
        </td>
        <td class="align-middle">
          <?= (new Select('optionDropDown', $optionDrop, ['id' => 'optionDropDown', 'onChange' => 'return amUpdateNewOptionValue(this.value);', 'class' => 'form-control form-control-sm']))->set_selection($selectedOption) ?>
        </td>
        <td class="align-middle">
          <button type="button" class="btn btn-secondary btn-sm" data-toggle="popup" data-placement="top" title="<?= AM_AJAX_ADDS_NEW_OPTION ?>" onclick="return customPrompt('amAddOption');"><i class="fas fa-plus-circle"></i></button>
        </td>
        <td class="align-middle">
          <?= AM_AJAX_VALUE . ':' ?>
        </td>
        <td class="align-middle">
          <?= (new Select('optionValueDropDown', $optionValueDrop, ['id' => 'optionValueDropDown', 'class' => 'form-control form-control-sm']))->set_selection(isset($selectedOptionValue) && is_numeric($selectedOptionValue) ? $selectedOptionValue : '') ?>
        </td>
        <td class="align-middle">
          <button type="button" class="btn btn-secondary btn-sm" data-toggle="popup" data-placement="top" title="<?= AM_AJAX_ADDS_NEW_OPTION_VALUE ?>" onclick="return customPrompt('amAddOptionValue');"><i class="fas fa-plus-circle"></i></button>
        </td>
  <?php
  // Begin options images added by @raiwa
        if (AM_USE_IMAGE == 'true') {
          ?>
          <td class="align-middle">
            <?= AM_AJAX_IMAGE ?>
        </td>
        <td class="align-middle">
            <?= new Input('newImage', ['id' => 'newImage', 'size' => '4', 'class' => 'form-control form-control-sm']) ?>
          </td>
          <?php
        }
  // End options images added by @raiwa
  ?>
        <td class="align-middle">
          <?= AM_AJAX_PREFIX ?>
        </td>
        <td class="align-middle">
          <?= drawDropDownPrefix(['id' => 'prefix_0', 'class' => 'form-control form-control-sm'])?>
        </td>
        <td class="align-middle">
          <?= AM_AJAX_PRICE ?>
        </td>
        <td class="align-middle">
          <?= new Input('newPrice', ['id' => 'newPrice', 'size' => '4', 'class' => 'form-control form-control-sm']) ?>
        </td>

  <?php
      // wholesale added by @BrockleyJohn 
      if (AM_USE_WHOLESALE == 'true') {
        echo sprintf('<td class="align-middle">%s</td>', new Input('whoPrice', ['id' => 'whoPrice', 'size' => '4', 'placeholder' => AM_AJAX_WHOLESALE, 'class' => 'form-control form-control-sm']));
      }

  // More Product Weight added by RusNN updated by @raiwa
      if (AM_USE_MPW == 'true') {
  ?>
        <td class="align-middle">
          <?= AM_AJAX_WEIGHT_PREFIX ?>
        </td>
        <td class="align-middle">
          <?= drawDropDownWeightPrefix(['id' => 'weight_prefix_0', 'class' => 'form-control form-control-sm'])?>
        </td>
        <td class="align-middle">
          <?= AM_AJAX_WEIGHT ?>
        </td>
        <td class="align-middle">
          <?= new Input('newWeight', ['id' => 'newWeight', 'size' => '4', 'class' => 'form-control form-control-sm']) ?>
        </td>
  <?php
    }
  ?>

        <td class="align-middle">
          <?= new Input('newSort', ['id' => 'newSort', 'size' => '4'], 'hidden') ?>
        </td>

        <td class="text-right align-middle">
          <button type="button" class="btn btn-success btn-sm" data-toggle="popup" data-placement="top" title="<?= AM_AJAX_ADDS_ATTRIBUTE_TO_PRODUCT ?>" onclick="return amAddAttributeToProduct();" ><i class="fas fa-check-circle"></i></button>
        </td>
      </tr>
    </tbody>
  </table>
<?php
  if (!isset($_GET['target'])) {
    echo '</div>';
  }
} // end target = newAttribute

if (!isset($_GET['target'])) {
  echo '</div>';
}
