<?php
/*
  $Id: attributeManager.php,v 3.6.0

  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Copyright © 2021 Rainer Schmied

  based on attributeManager.php,v 1.0 21/02/06 Sam West$

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Released under the GNU General Public License

  Copyright © 2006 Kangaroo Partners
  http://kangaroopartners.com
  osc@kangaroopartners.com
*/

require_once 'attributeManager/classes/amDB.class.php';
require_once 'attributeManager/includes/attributeManagerSessionFunctions.inc.php';

if ( file_exists('attributeManager/languages/' . $_SESSION['language'] . '/attributeManager.php') ) {
 include_once 'attributeManager/languages/' . $_SESSION['language'] . '/attributeManager.php';
} else {
 include_once 'attributeManager/languages/english/attributeManager.php';
}

class attributeManagerConfig {

	var $arrConfig = [];
  public $version = '3.4.2';

	function __construct() {

		/**
		 * Default admin interface language id
		 */
		$this->add('AM_DEFAULT_LANGUAGE_ID', $GLOBALS['languages_id']);

		/**
		 * Password for the session var - doesn't matter what it is. Mix it up if you fee like it :)
		 */
		$this->add('AM_VALID_INCLUDE_PASSWORD', 'asdfjkasdadfadsff');

		/**
		 * Variable names - Shouldn't need editing unless there are conflicts
		 */
		$this->add('AM_SESSION_VAR_NAME', 'am_session_var'); // main var for atomic
		$this->add('AM_SESSION_CURRENT_LANG_VAR_NAME', 'am_current_lang_session_var'); // current interface lang
		$this->add('AM_SESSION_CURRENT_TEMPLATE_ORDER', 'am_current_template_order'); // current template order
		$this->add('AM_SESSION_VALID_INCLUDE', 'am_valid_include'); // variable set on catalog.php to make sure attributeManager.php has been included
		$this->add('AM_SESSION_SORT_ORDER_INSTALL_CHECKED', 'am_sort_order_checked');
    $this->add('AM_SESSION_MORE_PRODUCT_WEIGHT_INSTALL_CHECKED', 'am_more_product_weight_checked');
    $this->add('AM_SESSION_ATTRIBUTE_MANAGER_UPDATE_CHECKED', 'am_update_checked');
		$this->add('AM_SESSION_TEMPLATES_INSTALL_CHECKED', 'am_templates_checked');
		$this->add('AM_ACTION_GET_VARIABLE', 'amAction'); // attribute manager get variable name
		$this->add('AM_PAGE_ACTION_NAME', 'pageAction'); // attribute manager parent page action e.g. new_product

    if ( !defined('AM_DEFAULT_TEMPLATE_ORDER') ) {
      $this->install_attribute_manager();
    }

    if ( !amSessionIsRegistered($this->getValue('AM_SESSION_ATTRIBUTE_MANAGER_UPDATE_CHECKED')) && !defined('AM_USE_QT_PRO') || !defined('AM_USE_WHOLESALE') || !defined('AM_USE_OPTION_TYPES') ) {
      $this->updateAttributeManager();
    }

		/**
		 * Install templates if not already done so
		 */
		$this->installTemplates();

		/**
		 * Install the More Product Weight fields if they dont already exist
		 */

		$this->installMoreProductWeight();

	}

	function load() {
		if (0 !== count($this->arrConfig)) {
			foreach ($this->arrConfig as $key => $value) {
				define($key, $value);
      }
    }
	}

	function getValue($key) {
		if ( array_key_exists($key, $this->arrConfig) ) {
			return $this->arrConfig[$key];
    }
		return false;
	}

	function add($key, $value) {
		$this->arrConfig[$key] = $value;
	}

  function install_attribute_manager() {
    global $db;

    $db->query(sprintf(<<<'EOSQL'
INSERT INTO configuration_group (configuration_group_title, configuration_group_description, sort_order, visible)
VALUES ('Ajax Attribute Manager', 'Ajax Attribute Manager Configuration values', '20', '1')
EOSQL
    , $this->version));

    $group_id = mysqli_insert_id($db);

    $db->query("INSERT INTO configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added, use_function, set_function) VALUES
                ('Template order', 'AM_DEFAULT_TEMPLATE_ORDER', '123', 'Default admin interface template order', '" . $group_id . "', '1', now(), null, '" . $db->escape("Config::select_one(array('123', 'abc'), ") . "'),
                ('Sort order in drop down', 'AM_DEFAULT_SORT_ORDER', '2', 'How do sort the drop down lists in the admin - purly asthetic<br>options:<br>1 = alpha<br>default - by id', '" . $group_id . "', '1', now(), null, '" . $db->escape("Config::select_one(array('1', '2'), ") . "'),
                ('Use Templates', 'AM_USE_TEMPLATES', 'true', 'Use attribute templates?', '" . $group_id . "', '1', now(), null, '" . $db->escape("Config::select_one(array('true', 'false'), ") . "'),
                ('Use Options Images', 'AM_USE_IMAGE', 'false', 'Use Options Images plugin?', '" . $group_id . "', '1', now(), null, '" . $db->escape("Config::select_one(array('true', 'false'), ") . "'),
                ('Use Options Attributes Weight', 'AM_USE_MPW', 'false', 'Use Options Attributes Weight plugin?', '" . $group_id . "', '1', now(), null, '" . $db->escape("Config::select_one(array('true', 'false'), ") . "'),
                ('Use QtPro', 'AM_USE_QT_PRO', 'false', 'Use QtPro plugin?', '" . $group_id . "', '1', now(), null, '" . $db->escape("Config::select_one(array('true', 'false'), ") . "'),
                ('Use Wholesale Lite', 'AM_USE_WHOLESALE', 'false', 'Use Wholesale Lite plugin?', '" . $group_id . "', '1', now(), null, '" . $db->escape("Config::select_one(array('true', 'false'), ") . "'),
                ('Use Option Types', 'AM_USE_OPTION_TYPES', 'false', 'Use Option Types plugin?', '" . $group_id . "', '1', now(), null, '" . $db->escape("Config::select_one(array('true', 'false'), ") . "');
              ");

  }

	function installTemplates() {
    global $db;

		if ( defined('AM_USE_TEMPLATES') && AM_USE_TEMPLATES == 'true' && !amSessionIsRegistered($this->getValue('AM_SESSION_TEMPLATES_INSTALL_CHECKED')) ) {

			$db->query("CREATE TABLE IF NOT EXISTS `am_templates` (
					`template_id` INT( 5 ) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
					`template_name` VARCHAR( 255 ) NOT NULL
				)"
			);
			$db->query("CREATE TABLE IF NOT EXISTS `am_attributes_to_templates` (
					`template_id` INT( 5 ) UNSIGNED NOT NULL ,
					`options_id` INT( 5 ) UNSIGNED NOT NULL ,
					`option_values_id` INT( 5 ) UNSIGNED NOT NULL ,
					`price_prefix` char(1) default '+',
					`options_values_price` decimal(15,4) default 0,
					`sort_order` int default 0,
					`option_image` varchar(127)  null default null,
          `option_weight_prefix` char(1) default '+',
          `option_weight` decimal(5,2) default '0.00',
					INDEX ( `template_id` )
				)"
			);
			// Check if the user is updating from the older version
			$install_price_prefix=true;
			$install_options_values_price=true;
      $install_more_product_weight=true;

			// Fetch database Fields
			$attributeFields = $db->query("SHOW COLUMNS FROM `am_attributes_to_templates`");
			while ($field = $attributeFields->fetch_assoc())  {
        $fields[] = $field['Field'];
      }

			if ( !in_array('price_prefix',$fields) ) {
				$db->query("ALTER TABLE `am_attributes_to_templates` ADD(`price_prefix` char(1) default '+')");
			}
			if ( !in_array('options_values_price',$fields) ) {
				$db->query("ALTER TABLE `am_attributes_to_templates` ADD(`options_values_price` decimal(15,4) default 0)");
			}
			if ( in_array('products_options_sort_order',$fields) ) {
				$db->query("ALTER TABLE `am_attributes_to_templates` CHANGE `products_options_sort_order` `sort_order` INT(11) NULL DEFAULT '0';");
			}
			if ( !in_array('sort_order',$fields) ) {
				$db->query("ALTER TABLE `am_attributes_to_templates` ADD(`sort_order` int default 0)");
			}
      if ( !in_array('option_image',$fields) ) {
        $db->query("ALTER TABLE `am_attributes_to_templates` ADD(`option_image` varchar(127)  null default null)");
      }
      if ( !in_array('options_weight_prefix',$fields) ) {
        $db->query("ALTER TABLE `am_attributes_to_templates` ADD(`options_weight_prefix` char(1) default '+')");
      }
      if ( !in_array('options_weight',$fields) ) {
        $db->query("ALTER TABLE `am_attributes_to_templates` ADD(`options_weight` decimal(6,3) default '0.000')");
      }
      if ( !in_array('options_values_ws_price',$fields) ) {
        $db->query("ALTER TABLE `am_attributes_to_templates` ADD(`options_values_ws_price` decimal(15,4) default 0)");
      }
      if ( !in_array('options_type',$fields) ) {
        $db->query("ALTER TABLE `am_attributes_to_templates` ADD(`options_type` INT(2) NOT NULL)");
      }
      if ( !in_array('options_length',$fields) ) {
        $db->query("ALTER TABLE `am_attributes_to_templates` ADD(`options_length` INT(2) NOT NULL DEFAULT '32')");
      }
      if ( !in_array('options_comment',$fields) ) {
        $db->query("ALTER TABLE `am_attributes_to_templates` ADD(`options_comment` VARCHAR(32) NULL DEFAULT NULL)");
      }

			// update products options and attributes table to Phoenix 1.0.7.10+ sort order
      if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_attributes' AND COLUMN_NAME LIKE 'sort_order'")) != 1 ) {
        $db->query("ALTER TABLE `products_attributes` ADD(`sort_order` int(3) default 0)");
      }
      if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_attributes' AND COLUMN_NAME LIKE 'products_options_sort_order'")) == 1 ) {
        $db->query("UPDATE `products_attributes` SET `sort_order`=`products_options_sort_order`");
        $db->query("ALTER TABLE `products_attributes` DROP `products_options_sort_order`");
      }

      if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_options' AND COLUMN_NAME LIKE 'products_options_sort_order'")) == 1 ) {
        $db->query("UPDATE `products_options` SET `sort_order`=`products_options_sort_order`");
        $db->query("ALTER TABLE `products_options` DROP `products_options_sort_order`");
      }

			// register the checked session so that this check is only done once per session
			amSessionRegister('AM_SESSION_TEMPLATES_INSTALL_CHECKED',true);

		}
	}

  function installMoreProductWeight() {
    global $db;

    if ( defined('AM_USE_MPW') && AM_USE_MPW == 'true' && !amSessionIsRegistered($this->getValue('AM_SESSION_MORE_PRODUCT_WEIGHT_INSTALL_CHECKED')) ) {
      // ADDED FIELDS
      if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_attributes' AND COLUMN_NAME LIKE 'option_weight'")) != 1 ) {
        $db->query("AlTER TABLE products_attributes ADD option_weight decimal(5,2) NOT NULL");
      }
      if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_attributes' AND COLUMN_NAME LIKE 'option_weight_prefix'")) != 1 ) {
        $db->query("AlTER TABLE products_attributes ADD option_weight_prefix char(1) NOT NULL");
      }
      // ADD FIELD for options values weight
      if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_options_values' AND COLUMN_NAME LIKE 'products_options_values_weight'")) != 1 ) {
        $db->query("AlTER TABLE products_options_values ADD products_options_values_weight decimal(5,2) NOT NULL");
      }
      if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_options_values' AND COLUMN_NAME LIKE 'products_options_values_weight_prefix'")) != 1 ) {
        $db->query("AlTER TABLE products_options_values ADD products_options_values_weight_prefix char(1) NOT NULL");
      }

      // register the checked session so that this check is only done once per session
      amSessionRegister($this->getValue('AM_SESSION_MORE_PRODUCT_WEIGHT_INSTALL_CHECKED'), true);
    }
  }

  function updateAttributeManager() {
    global $db;

    $am_group_query = $db->fetch_all("SELECT configuration_group_id FROM configuration_group WHERE configuration_group_title = 'Ajax Attribute Manager'");
    $group_id = $am_group_query[0]['configuration_group_id'];

    if ( !defined('AM_USE_QT_PRO') ) {
      $db->query("INSERT INTO configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added, use_function, set_function) VALUES
                  ('Use QtPro', 'AM_USE_QT_PRO', 'false', 'Use QtPro plugin?', '" . $group_id . "', '1', now(), null, '" . $db->escape("Config::select_one(array('true', 'false'), ") . "');
                 ");
    }

    if ( !defined('AM_USE_WHOLESALE') ) {
      $db->query("INSERT INTO configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added, use_function, set_function) VALUES
                  ('Use Wholesale Lite', 'AM_USE_WHOLESALE', 'false', 'Use Wholesale Lite plugin?', '" . $group_id . "', '1', now(), null, '" . $db->escape("Config::select_one(array('true', 'false'), ") . "');
                 ");
    }
    if ( !defined('AM_USE_OPTION_TYPES') ) {
      $db->query("INSERT INTO configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added, use_function, set_function) VALUES
                  ('Use Option Types', 'AM_USE_OPTION_TYPES', 'false', 'Use Option Types plugin?', '" . $group_id . "', '1', now(), null, '" . $db->escape("Config::select_one(array('true', 'false'), ") . "');
                 ");
    }

    // register the checked session so that this check is only done once per session
    amSessionRegister($this->getValue('AM_SESSION_ATTRIBUTE_MANAGER_UPDATE_CHECKED'), true);
  }

}

$config = new attributeManagerConfig();
$config->load();
