<?php
/*
  $Id: attributeManager.php,v 3.6.0.

  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  based on attributeManager.php,v 1.0 21/02/06 Sam West$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Released under the GNU General Public License

  Copyright © 2006 Kangaroo Partners
  http://kangaroopartners.com
  osc@kangaroopartners.com
*/

function yesNoButtons($section) {
  return '
  <div class="popupFooter">' .
    new Button(IMAGE_DELETE, 'fas fa-trash', 'btn-danger', ['onClick' => 'return ' . $section . '();']) . 
    new Button(IMAGE_CANCEL, 'fas fa-times', 'btn-light', ['onClick' => 'removeCustomPrompt();']) . 
  '</div>';
}

function updateCancelButtons($section) {
  return '
  <div class="popupFooter">' .
    new Button(IMAGE_SAVE, 'fas fa-save', 'btn-success', ['onClick' => 'return ' . $section . '();']) . 
    new Button(IMAGE_CANCEL, 'fas fa-times', 'btn-light', ['onClick' => 'removeCustomPrompt();']) . 
  '</div>';
}

function languageTextFields() {
  $return = '
  <table class="table table-sm">
    <tbody>';
  $languages = language::load_all();
	foreach ($languages as $amLanguage) {
    $return .='
      <tr>
        <td class="text-right">' . $GLOBALS['Admin']->catalog_image('includes/languages/' . $amLanguage['directory'] . '/images/' . $amLanguage['image'], [], $amLanguage['name']).'</td>
        <td>' . new Input('text_field_' . $amLanguage['id'], ['id' => $amLanguage['id']]) . '</td>
      </tr>';
    }
  if ($_GET['section']== 'amAddOption') {
    $return .= '<tr>';
    $return .= '  <td>' . AM_AJAX_SORT . ':</td><td>' . new Input('optionSortDropDown', ['value' => '', 'id' => 'optionSortDropDown', 'style' => 'margin:3px 0px 3px 0px;', 'size' => '4']);
    $return .= '</tr>';

// Options Type support added by @raiwa
    if (AM_USE_OPTION_TYPES  == 'true') {
      $drop_down_values = [['id' => 0, 'text' => AM_AJAX_OPTIONS_TYPE_SELECT_NAME],
                           ['id' => 1, 'text' => AM_AJAX_OPTIONS_TYPE_TEXT_NAME],
                           ['id' => 2, 'text' => AM_AJAX_OPTIONS_TYPE_TEXTAREA_NAME],
                           ['id' => 3, 'text' => AM_AJAX_OPTIONS_TYPE_RADIO_NAME],
                           ['id' => 4, 'text' => AM_AJAX_OPTIONS_TYPE_CHECKBOX_NAME],
                           ['id' => 5, 'text' => AM_AJAX_OPTIONS_TYPE_FILE_NAME]];
      $return .= '<tr>';                                                                                                  
      $return .= '  <td>' . AM_AJAX_OPTION_TYPE . ':</td><td>' . new Select('optionTypeDropDown', $drop_down_values, ['id' => 'optionTypeDropDown']) . '</td>';
      $return .= '</tr>';
      $return .= '<tr>';
      $return .= '  <td>' . AM_AJAX_OPTION_TYPE_LENGTH . ':</td><td>' . new Input('optionLengthDropDown', ['value' => '', 'id' => 'optionLengthDropDown', 'style' => 'margin:3px 0px 3px 0px;', 'size' => '4']);
      $return .= '</tr>';
      $return .= '<tr>';
      $return .= '  <td class="text-center">' . AM_AJAX_OPTION_TYPE_COMMENT . '</td>';
      $return .= '</tr>';
      foreach ($languages as $amLanguage) {
        $return .='
        <tr>
          <td class="text-right">' . $GLOBALS['Admin']->catalog_image('includes/languages/' . $amLanguage['directory'] . '/images/' . $amLanguage['image'], [], $amLanguage['name']).'</td>
          <td>' . new Input('optionCommentDropDown_' . $amLanguage['id'], ['value' => '', 'id' => 'optionCommentDropDown_' . $amLanguage['id'], 'style' => 'margin:3px 0px 3px 0px;', 'size' => '4']) . '</td>
        </tr>';
      }  
    }
    if (AM_USE_QT_PRO  == 'true') {
      $return .= '<tr>';
      $return .= '  <td colspan=2>';
      $return .= '<div class="form-group row align-items-center my-0">';
      $return .=   '<div class="col-form-label col-sm-6 text-left text-sm-right">' . AM_AJAX_TRACK_STOCK . '</div>';
      $return .=   '<div class="col-sm-6 custom-control custom-switch">';
      $return .=     new Tickable('stockTracking', ['value' => '0', 'class' => 'custom-control-input', 'id' => 'stockTracking'], 'checkbox');
      $return .=     '<label for="stockTracking" class="custom-control-label text-muted"><small>' . AM_AJAX_TRACK_STOCK_YES . '&nbsp;</small></label>';
      $return .=   '</div>';
      $return .= '</div>';
      $return .= '  </td>';
      $return .='	</tr>';
    }
  }
  $return .= '
    </tbody>
  </table>';
  return $return;
}


function okButton() {
	return '<input type="submit" align="center" value="' . AM_AJAX_OK . '" onClick="removeCustomPrompt();" />';
}

class amPopups {
	var $header = '';
	var $contents = '';

	function setHeader($string) {
		$this->header .= $string;
	}

	function addToContents($string) {
		$this->contents .= $string;
	}

	function output() {
		return '
		<div id="popupHeading">' . stripcslashes($this->header) . '</div>
		<div id="popupContainer">' . $this->contents . '</div>';
	}
}

// check that it is a prompt section
if ( isset($_GET[AM_ACTION_GET_VARIABLE]) && $_GET[AM_ACTION_GET_VARIABLE] == 'prompt' ) {

  $arrExtraValues = [];
  $valuePairs = [];

	// de encode the extra gets string
	if (isset($_GET['gets'])) {

		if (strpos($_GET['gets'], '|')) {
			$valuePairs = explode('|', $_GET['gets']);
		} else {
			$valuePairs[] = $_GET['gets'];
		}
		foreach ($valuePairs as $pair) {
			if (strpos($pair,':')) {
				list($extraKey, $extraValue) = explode(':', $pair);
				$arrExtraValues[$extraKey] = $extraValue;
			}
    }
	}

	switch($_GET['section']) {
		case 'amAddOption':
			$amPopup = new amPopups();
			$amPopup->setHeader(AM_AJAX_ENTER_NEW_OPTION_NAME);
			$amPopup->addToContents(languageTextFields());
			$amPopup->addToContents(updateCancelButtons(Text::prepare($_GET['section'])));
			echo $amPopup->output();
			break;
		case 'amAddOptionValue':
			$amPopup = new amPopups();
			$amPopup->setHeader(AM_AJAX_ENTER_NEW_OPTION_VALUE_NAME);
			$amPopup->addToContents(languageTextFields());
			$amPopup->addToContents(updateCancelButtons(Text::prepare($_GET['section'])));
			echo $amPopup->output();
			break;
		case 'amAddNewOptionValueToProduct':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_ENTER_NEW_OPTION_VALUE_NAME_TO_ADD_TO, $arrExtraValues['option_name']));
			$amPopup->addToContents(languageTextFields());
			$amPopup->addToContents(updateCancelButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(new Input('option_id', ['value' => $arrExtraValues['option_id'], 'id' => 'option_id'], 'hidden'));
			echo $amPopup->output();
			break;
		case 'amRemoveOptionFromProduct':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_PROMPT_REMOVE_OPTION_AND_ALL_VALUES, $arrExtraValues['option_name']));
			$amPopup->addToContents(yesNoButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(new Input('option_id', ['value' => $arrExtraValues['option_id'], 'id' => 'option_id'], 'hidden'));
			echo $amPopup->output();
			break;
		case 'amRemoveOptionValueFromProduct':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_PROMPT_REMOVE_OPTION, $arrExtraValues['option_value_name']));
			$amPopup->addToContents(yesNoButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(new Input('option_id', ['value' => $arrExtraValues['option_id'], 'id' => 'option_id'], 'hidden'));
			$amPopup->addToContents(new Input('option_value_id', ['value' => $arrExtraValues['option_value_id'], 'id' => 'option_value_id'], 'hidden'));

			echo $amPopup->output();
			break;
//----------------------------
// Change: image attributes for AM
//
// author: @raiwa
//-----------------------------
		case 'amAddNewImageForProduct':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_HEADER_IMAGE_ADD_NEW , $arrExtraValues['option_value_name']));
			$amPopup->addToContents('<div class = "amFieldset">');
			$amPopup->addToContents('<div class = "amFieldLabel">' . AM_AJAX_IMAGE . '</div><div class = "amField">' . new Input('option_image', ((isset($arrExtraValues['option_image']))? ['id' => 'option_image', 'value' => $arrExtraValues['option_image'], 'class' => 'form-control form-control-sm'] : ['id' => 'option_image', 'class' => 'form-control form-control-sm'])) );
			$amPopup->addToContents('</div>');
			$amPopup->addToContents('</div>');
			$amPopup->addToContents(updateCancelButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(new Input('option_id', ['value' => $arrExtraValues['option_id'], 'id' => 'option_id'], 'hidden'));
			$amPopup->addToContents(new Input('option_value_id', ['value' => $arrExtraValues['option_value_id'], 'id' => 'option_value_id'], 'hidden'));
			$amPopup->addToContents(new Input('products_attributes_id', ['value' => $arrExtraValues['products_attributes_id'], 'id' => 'products_attributes_id'], 'hidden'));
			echo $amPopup->output();
			break;
		case 'amDeleteImageForProduct':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_HEADER_IMAGE_DELETE, $arrExtraValues['option_value_name']));
			$amPopup->addToContents(yesNoButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(new Input('option_id', ['value' => $arrExtraValues['option_id'], 'id' => 'option_id'], 'hidden'));
			$amPopup->addToContents(new Input('option_value_id', ['value' => $arrExtraValues['option_value_id'], 'id' => 'option_value_id'], 'hidden'));
			$amPopup->addToContents(new Input('products_attributes_id', ['value' => $arrExtraValues['products_attributes_id'], 'id' => 'products_attributes_id'], 'hidden'));
			echo $amPopup->output();
			break;
//----------------------------
// EOF Change: image attributes for AM
//-----------------------------
//----------------------------
// Change: download attributes for AM
//
// author: mytool
//-----------------------------
		case 'amAddNewDownloadForProduct':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_HEADER_DOWLNOAD_ADD_NEW, $arrExtraValues['option_value_name']));
			$amPopup->addToContents('<div class="amFieldset">');
			$amPopup->addToContents('<div class = "amFieldLabel">' . AM_AJAX_FILENAME . '</div><div class = "amField">' . new Input('products_attributes_filename', ['id' => 'products_attributes_filename', 'class' => 'form-control form-control-sm']) );
			$amPopup->addToContents('</div>');
			$amPopup->addToContents('</div>');
			$amPopup->addToContents('<div class="amFieldset">');
			$amPopup->addToContents('<div class = "amFieldLabel">' . AM_AJAX_FILE_DAYS . '</div><div class = "amField">' . new Input('products_attributes_maxdays', ['id' => 'products_attributes_maxdays', 'value' => '7', 'class' => 'form-control form-control-sm']) );
			$amPopup->addToContents('</div>');
			$amPopup->addToContents('<div class="amFieldset">');
			$amPopup->addToContents('<div class = "amFieldLabel">' . AM_AJAX_FILE_COUNT . '</div><div class = "amField">' . new Input('products_attributes_maxcount', ['id' => 'products_attributes_maxcount', 'value' => '5', 'class' => 'form-control form-control-sm']) );
			$amPopup->addToContents('</div>');
			$amPopup->addToContents(updateCancelButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(new Input('option_id', ['value' => $arrExtraValues['option_id'], 'id' => 'option_id'], 'hidden'));
			$amPopup->addToContents(new Input('products_attributes_id', ['value' => $arrExtraValues['products_attributes_id'], 'id' => 'products_attributes_id'], 'hidden'));
			echo $amPopup->output();
			break;
		case 'amEditDownloadForProduct':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_HEADER_DOWLNOAD_EDIT , $arrExtraValues['option_value_name']));
			$amPopup->addToContents('<div class = "amFieldset">');
			$amPopup->addToContents('<div class = "amFieldLabel">' . AM_AJAX_FILENAME . '</div><div class = "amField">' . new Input('products_attributes_filename', ['id' => 'products_attributes_filename', 'value' => $arrExtraValues['products_attributes_filename'], 'class' => 'form-control form-control-sm']) );
			$amPopup->addToContents('</div>');
			$amPopup->addToContents('</div>');
			$amPopup->addToContents('<div class = "amFieldset">');
			$amPopup->addToContents('<div class = "amFieldLabel">' . AM_AJAX_FILE_DAYS . '</div><div class = "amField">' . new Input('products_attributes_maxdays', ['id' => 'products_attributes_maxdays', 'value' => $arrExtraValues['products_attributes_maxdays'], 'class' => 'form-control form-control-sm']) );
			$amPopup->addToContents('</div>');
			$amPopup->addToContents('<div class = "amFieldset">');
			$amPopup->addToContents('<div class = "amFieldLabel">' . AM_AJAX_FILE_COUNT . '</div><div class = "amField">' . new Input('products_attributes_maxcount', ['id' => 'products_attributes_maxcount', 'value' => $arrExtraValues['products_attributes_maxcount'], 'class' => 'form-control form-control-sm']) );
			$amPopup->addToContents('</div>');
			$amPopup->addToContents('</div>');
			$amPopup->addToContents(updateCancelButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(new Input('option_id', ['value' => $arrExtraValues['option_id'], 'id' => 'option_id'], 'hidden'));
			$amPopup->addToContents(new Input('products_attributes_id', ['value' => $arrExtraValues['products_attributes_id'], 'id' => 'products_attributes_id'], 'hidden'));
			echo $amPopup->output();
			break;
		case 'amDeleteDownloadForProduct':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_HEADER_DOWLNOAD_DELETE, $arrExtraValues['option_value_name']));
			$amPopup->addToContents(yesNoButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(new Input('option_id', ['value' => $arrExtraValues['option_id'], 'id' => 'option_id'], 'hidden'));
			$amPopup->addToContents(new Input('products_attributes_id', ['value' => $arrExtraValues['products_attributes_id'], 'id' => 'products_attributes_id'], 'hidden'));
			echo $amPopup->output();
			break;
//----------------------------
// EOF Change: download attributes for AM
//-----------------------------

		case 'loadTemplate':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_PROMPT_LOAD_TEMPLATE, $arrExtraValues['template_name']));
			$amPopup->addToContents(yesNoButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(new Input('template_id', ['value' => $arrExtraValues['template_id'], 'id' => 'template_id'], 'hidden'));
			echo $amPopup->output();
			break;
		case 'saveTemplate':
			$amPopup = new amPopups();
			$amPopup->setHeader(AM_AJAX_NEW_TEMPLATE_NAME_HEADER);
      $amPopup->addToContents(AM_AJAX_NEW_NAME . '&nbsp' . new Input('template_name', ['id' => 'template_name', 'onChange' => '((this.value != \'\') ? document.getElementById(\'existing_template\').selectedIndex = 0 : \'\')', 'class' => 'form-control form-control-sm']));
			$templatesDrop = $attributeManager->buildAllTemplatesDropDown();
			$amPopup->setHeader(AM_AJAX_CHOOSE_EXISTING_TEMPLATE_TO_OVERWRITE);
      $amPopup->addToContents(AM_AJAX_CHOOSE_EXISTING_TEMPLATE_TITLE . '&nbsp' .  new Select('existing_template', $templatesDrop, ['id' => 'existing_template', 'onChange' =>' document.getElementById(\'template_name\').value=\'\';']));
			$amPopup->addToContents(updateCancelButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(((isset($arrExtraValues['template_id']))? new Input('template_id', ['value' => $arrExtraValues['template_id'], 'id' => 'template_id'], 'hidden') : new Input('template_id', ['id' => 'template_id'], 'hidden')));
			echo $amPopup->output();
			break;
		case 'renameTemplate':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_RENAME_TEMPLATE_ENTER_NEW_NAME, $arrExtraValues['template_name']));
      $amPopup->addToContents(AM_AJAX_NEW_NAME . '&nbsp' . new Input('template_new_name', ['id' => 'template_new_name', 'class' => 'form-control form-control-sm']));
			$amPopup->addToContents(updateCancelButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(new Input('template_id', ['value' => $arrExtraValues['template_id'], 'id' => 'template_id'], 'hidden'));
			echo $amPopup->output();
			break;
		case 'deleteTemplate':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_PROMPT_DELETE_TEMPLATE, $arrExtraValues['template_name']));
			$amPopup->addToContents(yesNoButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(new Input('template_id', ['value' => $arrExtraValues['template_id'], 'id' => 'template_id'], 'hidden'));
			echo $amPopup->output();
			break;
		case 'debug':
			$amPopup = new amPopups();
			$amPopup->setHeader(implode($valuePairs, ','));
			$amPopup->addToContents(yesNoButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(new Input('debug', ['value' => $arrExtraValues['debug'], 'id' => 'debug'], 'hidden'));
			echo $amPopup->output();
			break;
	}

}
